// Program title:- Implementation of dictionary of keywords and various operations on dictionary.
// Roll no.:
//Batch: S2

#include<iostream> //header file for i/o statements
#include<stdlib.h> //header file for standard library functions
using namespace std; //for standard i/o statements
#include<string.h> //header file for string functions
#define size 50 //define size as 50 
struct dictionary //structure of dictionary
{
	char keyword[10]; //variable declaration
	char meaning[20]; //variable declaration
	int valid; //variable declaration
}d[size];

void init(); //function declaration
int insert(int); //function declaration
void del(int); //function declaration
void modify(int); //function declaration
void sort(int); //function declaration
void search(int); //function declaration
void disp(int); //function declaration

int main() main function definition
{
	int ch,n=0; //variable declaration
	char ans; //variable declaration
	init(); //function call
	cout<<"\n Welcome To My Dictionary";
	do //do-while loop
	{
		cout<<"\n MENU";
		cout<<"\n1. Insert\n2. Delete\n3. Modify\n4. Sort\n5. Search\n6. Display";
		cout<<"\nEnter your choice"; //accept choice
		cin>>ch;
		switch(ch) //switch case
		{
			case 1:n=insert(n); //function call
				break;
			case 2:del(n); //function call
				break;
			case 3:modify(n); //function call
				break;
			case 4:sort(n); //function call
				break;
			case 5:search(n); //function call
				break;
			case 6: disp(n); //function call
				break;
			default:cout<<"Enter valid choice";
		}
		cout<<"\nDo you want to continue?(y/n)";
		cin>>ans;
	}while(ans=='y'||ans=='Y'); //repeat until ans is not y OR Y
	return 0;
}
void init() //function definition
{
	for(int i=0;i<size;i++) //repeat from 0 to size-1
	{
		strcpy(d[i].keyword,"");
		strcpy(d[i].meaning,"");
		d[i].valid=-1;
	}
return;
}
int insert(int no)  //function definition
{
	if(no<size) //check if condition
	{
		cout<<"\nEnter the Keyword";
		cin>>d[no].keyword;
		cout<<"\nEnter the Meaning";
		cin>>d[no].meaning;
		d[no].valid=1;
		no++;
	}
	else
	{
		cout<<"\nDatabase is full.....!!!!!";
	}
	return no;
}
void del(int no) //function definition
{
	char *key;
	int flag=0;
	cout<<"\nEnter the keyword you want to delete";
	cin>>key;
	for(int i=0;i<no;i++) //repeat from 0 to no-1
	{
		if(strcmp(d[i].keyword,key)==0)
		{
			d[i].valid=-1;
			flag=1;
			cout<<"\n Record is deleted sucessfully";
		}
	}
	if(flag==0) //check if condition
	{
		cout<<"\n Record not found";
	}
	return;
}
void modify(int no) //function definition
{
	char *key;
	char *new_key,*new_meaning;

	int flag=0;
	cout<<"\nEnter the keyword you want to modify";
	cin>>key;
	for(int i=0;i<no;i++) //repeat from 0 to no-1
	{
		if(strcmp(d[i].keyword,key)==0)
		{

			cout<<"\nEnter the new keyword";
			cin>>new_key;
			cout<<"\nEnter the new meaning";
			cin>>new_meaning;
			strcpy(d[i].keyword,new_key);
			strcpy(d[i].meaning,new_meaning);
			flag=1;
			cout<<"\n Record is modified sucessfully";
		}
	}
	if(flag==0) //check if condition
	{
		cout<<"\n Record not found";
	}
	return;
}
void sort(int no) //function definition
{
       char *s;
       char *s1;
       for(int i=0;i<no-1;i++) //repeat from 0 to no-1
	{
		for(int j=i+1;j<no;j++) //repeat from 0 to no-1
		{
			if(strcmp(d[i].keyword,d[j].keyword)<0) //check if condition
			{
				strcpy(s,d[i].keyword);
				strcpy(d[i].keyword,d[j].keyword);
				strcpy(d[j].keyword,s);

				strcpy(s1,d[i].meaning);
				strcpy(d[i].meaning,d[j].meaning);
				strcpy(d[j].meaning,s1);
			}
		}
	}
       cout<<"\nDictionary entries are sorted";
       return;
}
void search(int no) //function definition
{
	char *key;
	int flag=0,cnt=0;
	cout<<"\nEnter the keyword you want to search";
	cin>>key;
	for(int i=0;i<no;i++) //repeat from 0 to no-1
	{
		cnt++;
		if(strcmp(d[i].keyword,key)==0) //check if condition
		{

			flag=1;
			break;
		}
	}
	if(flag==1) //check if condition
	{
		cout<<"\nMeaning is="<<d[i].meaning;
		cout<<"\nThe comparisons made="<<cnt;
	}
	else
	{
		cout<<"\n Record not found";
	}
return;
}
void disp(int no) //function definition
{
	clrscr();
	cout<<"\n\nKeywords\t\t\tMeaning";
	cout<<"\n-------------------------------------";
	for(int i=0;i<no;i++) //repeat from 0 to no-1
	{
		if(d[i].valid==1) //check if condition
		{
			cout<<"\n"<<d[i].keyword<<"\t\t\t"<<d[i].meaning;
		}
	}
return;
}

/* ***OUTPUT***
 Welcome To My Dictionary
 MENU
1. Insert
2. Delete
3. Modify
4. Sort
5. Search
6. Display
Enter your choice 1

Enter the Keyword night

Enter the Meaning darkness

Do you want to continue?(y/n)y

 MENU
1. Insert
2. Delete
3. Modify
4. Sort
5. Search
6. Display
Enter your choice1

Enter the Keyword distinct

Enter the Meaning unique

Do you want to continue?(y/n)y

 MENU
1. Insert
2. Delete
3. Modify
4. Sort
5. Search
6. Display
Enter your choice 6


Keywords			Meaning
-------------------------------------
night			darkness
distinct			unique
Do you want to continue?(y/n)y

 MENU
1. Insert
2. Delete
3. Modify
4. Sort
5. Search
6. Display
Enter your choice 3

Enter the keyword you want to modify distinct
Enter the new keyword unique
Enter the new meaning different
Record is modified sucessfully
Do you want to continue?(y/n)y

 MENU
1. Insert
2. Delete
3. Modify
4. Sort
5. Search
6. Display
Enter your choice 6


Keywords			Meaning
-------------------------------------
night			darkness
unique				different
Do you want to continue?(y/n)y

 MENU
1. Insert
2. Delete
3. Modify
4. Sort
5. Search
6. Display
Enter your choice 2

Enter the keyword you want to delete night
Record is deleted sucessfully
Do you want to continue?(y/n)n

*/
