/*************************************************************/
//Roll no.:-
//Program title:- Implementation of Queue using Linked List

#include<iostream.h>
#include<conio.h>

class Queue
{
	struct node
	{
		int data;
		node *next;
	}*front,*rear,*temp;
	public:
		Queue()
		{
			front=rear=NULL;
		}
		void insert();
		void del();
		void disp();
};

void Queue::insert()
{
	node *new1;
	new1=new node;
	cout<<"\nEnter Data:";
	cin>>new1->data;
	new1->next=NULL;
	if(rear==NULL)
	{
		rear=new1;
		front=new1;
	}
	else
	{
		rear->next=new1;
		rear=new1;
	}
return;
}

void Queue::del()
{
	if(front==rear||rear==NULL)
	{
		cout<<"\nQueue Empty";
	}
	else
	{
		temp=front;
		cout<<"\nDeleted element is:"<<front->data;
		front=front->next;
		temp->next=NULL;
	}
return;
}

void Queue::disp()
{
	if(rear==NULL||front==NULL)
	{
		cout<<"\nStack Empty";
	}
	else
	{
		temp=front;
		cout<<"\nStack Elements are:\n";
		do
		{
			cout<<"\t"<<temp->data;
			temp=temp->next;
		}while(temp!=NULL);
	}
return;
}

void main()
{
	int ch;
	char ans;
	clrscr();
	Queue q;
	do
	{
		cout<<"\n***MENU***";
		cout<<"\n1.Insert\n2.Delete\n3.Display";
		cout<<"\n\nEnter choice:";
		cin>>ch;
		switch(ch)
		{
			case 1: q.insert();
				break;
			case 2: q.del();
				break;
			case 3: q.disp();
				break;
			default: cout<<"\nSorry... Enter valid choice...";
		}
		cout<<"\nDo you want to continue:(y:yes):";
		cin>>ans;
	}while(ans=='y'||ans=='Y');
	getch();
return;
}
/* OUTPUT:

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:1

Enter Data:10

Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:1

Enter Data:20

Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:1

Enter Data:30

Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:3

Stack Elements are:
	10      20      30
Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:2

Deleted element is:10

Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:3

Stack Elements are:
	20      30
Do you want to continue:(y:yes):n
*/
