/*************************************************************/
//Roll no.:-
//Program title:- Implementation of Stack using Linked List

#include<iostream.h>
#include<conio.h>

class stack
{
	struct node
	{
		int data;
		node *next;
	}*top,*temp;
	public:
		stack()
		{
			top=NULL;
		}
		void push();
		void pop();
		void disp();
};

void stack::push()
{
	node *new1;
	new1=new node;
	cout<<"\nEnter Data:";
	cin>>new1->data;
	new1->next=NULL;
	if(top==NULL)
	{
		top=new1;
	}
	else
	{
		new1->next=top;
		top=new1;
	}
return;
}

void stack::pop()
{
	if(top==NULL)
	{
		cout<<"\nStack Empty";
	}
	else
	{
		temp=top;
		cout<<"\nPoped element is:"<<temp->data;
		top=top->next;
		temp->next=NULL;
	}
return;
}

void stack::disp()
{
	if(top==NULL)
	{
		cout<<"\nStack Empty";
	}
	else
	{
		temp=top;
		cout<<"\nStack Elements are:\n";
		do
		{
			cout<<"\t"<<temp->data;
			temp=temp->next;
		}while(temp!=NULL);
	}
return;
}

void main()
{
	int ch;
	char ans;
	clrscr();
	stack st;
	do
	{
		cout<<"\n***MENU***";
		cout<<"\n1.PUSH\n2.POP\n3.Display";
		cout<<"\n\nEnter choice:";
		cin>>ch;
		switch(ch)
		{
			case 1: st.push();
				break;
			case 2: st.pop();
				break;
			case 3: st.disp();
				break;
			default: cout<<"\nSorry... Enter valid choice...";
		}
		cout<<"\nDo you want to continue:(y:yes):";
		cin>>ans;
	}while(ans=='y'||ans=='Y');
	getch();
return;
}

/* OUTPUT:

***MENU***
1.PUSH
2.POP
3.Display

Enter choice:1

Enter Data:10

Do you want to continue:(y:yes):y

***MENU***
1.PUSH
2.POP
3.Display

Enter choice:1

Enter Data:20

Do you want to continue:(y:yes):y

***MENU***
1.PUSH
2.POP
3.Display

Enter choice:1

Enter Data:30

Do you want to continue:(y:yes):y

***MENU***
1.PUSH
2.POP
3.Display

Enter choice:3

Stack Elements are:
	30      20      10
Do you want to continue:(y:yes):y

***MENU***
1.PUSH
2.POP
3.Display

Enter choice:2

Poped element is:30

Do you want to continue:(y:yes):y

***MENU***
1.PUSH
2.POP
3.Display

Enter choice:3

Stack Elements are:
	20      10
Do you want to continue:(y:yes):n
*/