/*************************************************************/
//Roll no.:-
//Program title:- Implementation of Threaded Binary Tree

#include<iostream.h>
#include<conio.h>

//Structure of a Node in BST
int top=-1;
class thread
{
	struct node
	{
		int data;
		int lth;
		int rth;
		struct node *left;
		struct node *right;
	}*root,*dummy;			//Pointer to root node in BST
	struct node *arr[10];

	//Prototypes of Functions
	public:
		void init();
		void search();
		void insert();
		void del1();
		void del(node *,node *,int);
		void add(node *,node *);
		void find(node **,node **,node *,int,int *);
		void disp1();
		void inorder(node *,node *);
};

void main()
{
	int ch,data;
	char ans;
	clrscr();
	thread t1;
	t1.init();
	do
	{
		cout<<"\n***Menu***";
		cout<<"\n1.Insert\n2.Inorder Display\n3.Delete node\n4.Search Node";
		cout<<"\n\nEnter Choice:";
		cin>>ch;
		switch(ch)
		{
			case 1: t1.insert();
				break;
			case 2: t1.disp1();
				break;
			case 3: t1.del1();
				break;
			case 4: t1.search();
				break;
			default: cout<<"\n\nSorry...!!! Enter the Valid Choice";
		}
		cout<<"\n\nDo you want to continue:(y-yes):";
		cin>>ans;
	}while(ans=='y'||ans=='Y');
	getch();
}

//Initializing root
void thread::init()
{
       root=NULL;
return;
}

//Inserting Node in a BST
void thread::insert()
{
	node *new1;
	char ch1;
	do
	{
		new1=new node;
		cout<<"\nEnter Data to insert:";
		cin>>new1->data;
		new1->left=NULL;
		new1->right=NULL;
		new1->lth=0;
		new1->rth=0;
		if(root==NULL)
		{
			root=new1;
			//node *dummy;
			dummy=new node;
			dummy->data=-999;
			dummy->left=root;
			dummy->lth=1;
			dummy->rth=0;
			dummy->right=NULL;
			root->left=dummy;
			root->right=dummy;
		}
		else
		{
			add(root,new1);
		}
		cout<<"\nDo you want to insert another node:(y:yes):";
		cin>>ch1;
	}while(ch1=='y'||ch1=='Y');
return;
}

void thread::add(node *temp,node *new1)
{
	if(new1->data<temp->data)
	{
		if(temp->lth==0)
		{
			new1->left=temp->left;
			temp->left=new1;
			temp->lth=1;
			new1->right=temp;
		}
		else
		{
			add(temp->left,new1);
		}
	}
	if(new1->data>temp->data)
	{
		if(temp->rth==0)
		{
			new1->right=temp->right;
			temp->right=new1;
			temp->rth=1;
			new1->left=temp;
		}
		else
		{
			add(temp->right,new1);
		}
	}
return;
}

void thread::disp1()
{
	if(root==NULL)
	{
		cout<<"\nTREE EMPTY";
	}
	else
	{
		inorder(root,dummy);
	}
return;
}

//Displaying contents of a TBT in Inorder
/*void thread::inorder(node *temp,node *dummy)
{
	while(temp!=dummy)
	{
		while(temp->lth==1)
		{
			temp=temp->left;
		}
		cout<<"\t"<<temp->data;
		while(temp->rth==0)
		{
			temp=temp->right;
			if(temp==dummy)
			{
				return;
			}
			cout<<"\t"<<temp->data;
		}
		temp=temp->right;
	}
return;
} */

void thread::inorder(node *root,node *dummy)
{
	while(root->lth==1)
	{
		root=root->left;
	}
	do
	{
		cout<<"\t"<<root->data;
		if(root->rth==1)
		{
			root=root->right;
			while(root->lth==1)
			{
				root=root->left;
			}
		}
		else
		{
			root=root->right;
		}
	}while(root!=dummy);
return;
}

void thread::search()
{
	int no,flag=0;
	struct node *temp,*parent;
	temp=root;
	if(root==NULL)
	{
		cout<<"\nTREE EMPTY";
	}
	else
	{
		cout<<"\nEnter no. to search:";
		cin>>no;
		find(&temp,&parent,dummy,no,&flag);
		if(flag==1)
		{
			cout<<"\nNode Found";
			cout<<"\nParent of "<<no<<" is "<<parent->data;
		}
		else
		{
			cout<<"\nNode not Found";
		}
	}
return;
}

//Search node from a TBT
void thread::find(node **temp,node **parent,node *dummy,int no,int *flag)
{
	while(*temp!=dummy)
	{
		*parent=*temp;
		if(no<(*temp)->data)
		{
			*temp=(*temp)->left;
		}
		if(no>(*temp)->data)
		{
			*temp=(*temp)->right;
		}
		if(no==(*temp)->data)
		{
			*flag=1;
			break;
		}
	}
return;
}

void thread::del1()
{
	int no;
	cout<<"\nEnter the element you want to delete:";
	cin>>no;
	del(root,dummy,no);
return;
}

void thread::del(node *temp,node *dummy,int data)
{
	int flag1=0;
	node *parent,*temp_succ;
	int flag=0;
	find(&temp,&parent,dummy,data,&flag1);
	if(flag1==1)
	{
		if(root==temp)
		{
			cout<<"\nIts Root node which can not be deleted...!!!";
			return;
		}
		//Deleting a node with two children
		if(temp->lth==1 && temp->rth==1)
		{
			parent=temp;
			temp_succ=temp->right;
			while(temp_succ->lth==1)
			{
				flag=1;
				parent=temp_succ;
				temp_succ=temp_succ->left;
			}
			if(flag==0)
			{
				temp->data=temp_succ->data;
				parent->right=temp_succ->right;
				parent->rth=0;
			}
			else
			{
				temp->data=temp_succ->data;
				parent->rth=0;
				parent->lth=0;
				parent->left=temp_succ->left;
			}
			cout<<"Node Deleted...";
			//delete(temp);
			return;
		}
		//Deleting a node having only one child (left child)
		if(temp->lth==1 && temp->rth==0)
		{
			if(parent->left==temp)
			{
				(temp->left)->right=parent;
				parent->left=temp->left;
			}
			else
			{
				(temp->left)->right=temp->right;
				parent->right=temp->left;
			}
			temp=NULL;
			delete(temp);
			cout<<"Node deleted...";
		}
		//The node to be deleted has right child
		if(temp->lth==0 && temp->rth==1)
		{
			if(parent->left==temp)
			{
				parent->left=temp->right;
				(temp->right)->left=temp->left;
				(temp->right)->right=parent;
			}
			else
			{
				parent->right=temp->right;
				(temp->right)->left=parent;
			}
			temp->left=NULL;
			temp->right=NULL;
			delete(temp);
			cout<<"\n Node deleted...";
		}
		//deleting node hving no child
		if(temp->lth==0 && temp->rth==0)
		{
			if(parent->left==temp)
			{
				parent->left=NULL;
				parent->left=temp->left;
				parent->lth=0;
			}
			else
			{
				parent->right=NULL;
				parent->right=temp->right;
				parent->rth=0;
			}
			cout<<"\n Node deleted...";
			delete(temp);
		}
	}
	else
	{
		cout<<"\nNODE NOT FOUND";
	}
return;
}
/* OUTPUT
***Menu***
1.Insert
2.Inorder Display
3.Delete node
4.Search Node

Enter Choice:1

Enter Data to insert:10

Do you want to insert another node:(y:yes):y

Enter Data to insert:5

Do you want to insert another node:(y:yes):y

Enter Data to insert:17

Do you want to insert another node:(y:yes):y

Enter Data to insert:2

Do you want to insert another node:(y:yes):y

Enter Data to insert:9

Do you want to insert another node:(y:yes):y

Enter Data to insert:14

Do you want to insert another node:(y:yes):y

Enter Data to insert:19

Do you want to insert another node:(y:yes):n


Do you want to continue:(y-yes):y

***Menu***
1.Insert
2.Inorder Display
3.Delete node
4.Search Node

Enter Choice:2
        2       5       9       10      14      15      17      19

Do you want to continue:(y-yes):y

***Menu***
1.Insert
2.Inorder Display
3.Delete node
4.Search Node

Enter Choice:3

Enter the element you want to delete:5
Node Deleted...

Do you want to continue:(y-yes):y

***Menu***
1.Insert
2.Inorder Display
3.Delete node
4.Search Node

Enter Choice:2
        2       9       10      14     15     17      19

Do you want to continue:(y-yes):y

***Menu***
1.Insert
2.Inorder Display
3.Delete node
4.Search Node

Enter Choice:4

Enter no. to search:10

Node Found
Parent of 10 is 10

Do you want to continue:(y-yes):y

***Menu***
1.Insert
2.Inorder Display
3.Delete node
4.Search Node

Enter Choice:4

Enter no. to search:19

Node Found
Parent of 19 is 17

Do you want to continue:(y-yes):n
*/