/*************************************************************/
//Roll no.:-
//Program title:- Implementation of Double Linked List

#include<iostream.h>
#include<conio.h>

class dll
{
	struct node
	{
		int data;
		node *next;
		node *prev;
	}*head,*temp;
	public:
		dll()
		{
			head=NULL;
		}
		void insert();
		void del();
		void disp();
};

void dll::insert()
{
	node *new1;
	new1=new node;
	cout<<"\nEnter Data:";
	cin>>new1->data;
	new1->next=NULL;
	new1->prev=NULL;
	if(head==NULL)
	{
		head=new1;
	}
	else
	{
		temp=head;
		while(temp->next!=NULL)
		{
			temp=temp->next;
		}
		temp->next=new1;
		new1->prev=temp;
	}
return;
}

void dll::del()
{
	int no;
	if(head==NULL)
	{
		cout<<"\nList Empty\n";
	}
	else
	{
		cout<<"\nEnter data to delete:";
		cin>>no;
		temp=head;
		do
		{
			if(temp->data==no)
			{
				if(temp==head&&head->next!=NULL)
				{
					head=head->next;
					head->prev=NULL;
					cout<<"\Node deleted";
					break;
				}
				if(temp==head&&head->next==NULL)
				{
					head=NULL;
					cout<<"\Node deleted";
					break;
				}
				if(temp->next==NULL)
				{
					temp->prev->next=NULL;
					temp->prev=NULL;
					cout<<"\Node deleted";
					break;
				}
				else
				{
					temp->prev->next=temp->next;
					temp->next->prev=temp->prev;
					cout<<"\Node deleted";
					break;
				}
			}
			else
			{
				temp=temp->next;
			}
		}while(temp!=NULL);
	}
return;
}

void dll::disp()
{
	if(head==NULL)
	{
		cout<<"\nList Empty";
	}
	else
	{
		temp=head;
		cout<<"\nElements are:\n";
		do
		{
			cout<<"\t"<<temp->data;
			temp=temp->next;
		}while(temp!=NULL);
	}
return;
}

void main()
{
	int ch;
	char ans;
	clrscr();
	dll d;
	do
	{
		cout<<"\n***MENU***";
		cout<<"\n1.Insert\n2.Delete\n3.Display";
		cout<<"\n\nEnter choice:";
		cin>>ch;
		switch(ch)
		{
			case 1: d.insert();
				break;
			case 2: d.del();
				break;
			case 3: d.disp();
				break;
			default: cout<<"\nSorry... Enter valid choice...";
		}
		cout<<"\nDo you want to continue:(y:yes):";
		cin>>ans;
	}while(ans=='y'||ans=='Y');
	getch();
}

/* OUTPUT:

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:1

Enter Data:10

Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:1

Enter Data:20

Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:1

Enter Data:30

Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:3

Elements are:
	10      20      30
Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:2

Enter data to delete:30
Node deleted

Do you want to continue:(y:yes):y

***MENU***
1.Insert
2.Delete
3.Display

Enter choice:3

Elements are:
	10      20
Do you want to continue:(y:yes):n
*/